uniform sampler3D ctex;
uniform sampler3D ntex;

//varying vec3 normal, tangent, bitang;
varying vec3 ldir;

#define unpack_vec(v) \
	(((v).xyz) * 2.0 - 1.0)

#define pack_vec(v) \
	vec4((v) * 0.5 + 0.5, 1.0)

void main()
{
	vec4 cloud = texture3D(ctex, gl_TexCoord[0].xyz);
	vec3 norm = unpack_vec(texture3D(ntex, gl_TexCoord[0].xyz));

	float dif = max(dot(norm, normalize(ldir)), 0.0) * 0.7 + 0.3;

	vec3 rgb = cloud.xyz * dif;

	gl_FragColor = vec4(rgb, cloud.w);
}
